
local TargetAssist = LibStub("AceAddon-3.0"):NewAddon("TargetAssist","AceEvent-3.0")

local AudioDiff
local addonName = GetAddOnMetadata("Target Assist", "Title");

local TAicon = LibStub("LibDBIcon-1.0")

local function leadtoggle()
    if(leadstatus) then
        leadstatus = false
        print("|cff5488A5When you are raid lead/assist you will no longer share your assist target with others")
    else
        leadstatus = true
        print("|cff5488A5When you are raid lead/assist you are sharing your assist target with others")
    end
end

local function TAAssist(arg1)
    local action, command, bindkey = strsplit(" ", arg1, 3)
    if(action == "leadtoggle") then
        leadtoggle()
    end
    if(action == "help") then
        print("|cff5488A5/taa <action> <command> <bindkey> to keybind either \"Assist\" or \"AttackTarget\" commands.|nBindkey format can be in Blizzard accepted bind such as SHIFT-J or NUMPAD7 eg: \"/taa bind assist Shift-J\"|n|nIf you are raid lead or assist and do not want other players in a raid to get your target \"/taa leadtoggle\"")
    end
    if(action == "bind") then
        if(command == "attacktarget") then
            SetBindingClick(bindkey, AssistBtn:GetName())
            print("|cff5488A5Successfully bound \"on my target\" call to",bindkey)
            attacktargetkeybind = bindkey
        elseif(command == "assist") then
            SetBindingClick(bindkey, SetAssistBtn:GetName())
            print("|cff5488A5Successfully bound assist target to",bindkey)
            assisttargetkeybind = bindkey
        end
    --AssistBtn:Toggle()
    --LibStub("LibKeyBound-1.0"):Toggle()
    end
end

function TargetAssist:OnInitialize()
    self.db = LibStub("AceDB-3.0"):New("TargetAssistDB", { profile = { minimap = { hide = false, }, }, })
    --self:SetScript("OnEvent", Addon_OnEvent)
    if (attacktargetkeybind == nil) then attacktargetkeybind = "SHIFT-;" end
    if (assisttargetkeybind == nil) then assisttargetkeybind = "SHIFT-'" end
    if (leadstatus == nil) then leadstatus = true end
    self:RegisterEvent("CHAT_MSG_ADDON");
    self:RegisterEvent("PLAYER_LOGIN")
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    DrawTAMinimapIcon()
    TAAssist("bind assist "..assisttargetkeybind)
    TAAssist("bind attacktarget "..attacktargetkeybind)
    --[[local kb = LibStub("LibKeyBound-1.0")
	kb.RegisterCallback(self, "LIBKEYBOUND_ENABLED")
	kb.RegisterCallback(self, "LIBKEYBOUND_DISABLED")--]]
end

--[[ keybound events
function TargetAssist:LIBKEYBOUND_ENABLED()
    --TargetAssist:OtherModeOff()
    TargetAssist.keyBoundMode = true
    --TargetAssist:ColorMyMod()
end

function TargetAssist:LIBKEYBOUND_DISABLED()
	TargetAssist.keyBoundMode = nil
	--TargetAssist:ColorMyMod()
end
--]]
local function SetAssist()
    TAassistPlayer = UnitName("target");
    --C_ChatInfo.SendAddonMessage("TAssist", UnitName("Player").."&Register", "WHISPER",TAassistPlayer)
    C_ChatInfo.SendAddonMessage("TAssist", UnitName("Player").."&Register", "WHISPER",TAassistPlayer)
    ChatFrame1:AddMessage('|cff5488A5Current assist is: |cffD9534F' .. TAassistPlayer);
    if(UnitIsGroupAssistant("Player") or UnitIsGroupLeader("Player")) then
        if(leadstatus) then
            print("|cff5488A5You are the raid leader or assistant. Your target has been announced to the raid as|cffD9534F",TAassistPlayer)
            C_ChatInfo.SendAddonMessage("TAssist", UnitName("Target").."&LeadRegister", "RAID")--avoid a loop here
        end
    end
    --[[if(IsRaidLeader()) then
        print("leader")
    end--]]
end

local function LeadAssist(leadtarget,leadsender)
    if(UnitIsGroupAssistant(leadsender) or UnitIsGroupLeader(leadsender)) then
        TAassistPlayer = leadtarget
        C_ChatInfo.SendAddonMessage("TAssist", UnitName("Player").."&Register", "WHISPER",TAassistPlayer)
        ChatFrame1:AddMessage('|cff5488A5'..leadsender..' has set the assist to: |cffD9534F' .. TAassistPlayer);
    end
end

local function OnMyTarget()--Sends out a message to attack my target(to those who are listed in the TAAlertGroup table)
    for _, value in pairs(TAAlertGroup) do
        if(UnitName("Target")) then
            C_ChatInfo.SendAddonMessage("TAssist", UnitName("Target").."&Attack", "RAID")--"WHISPER",value)--Change to raid, not whisper, after testing
            --C_ChatInfo.SendAddonMessage("TAssist", UnitName("Target").."&Attack", "WHISPER",value)--Change to raid, not whisper, after testing, or leave as whisper to send to all those "following" you?
            if(GetRaidTargetIndex("Target") ~= 8) then
                SetRaidTarget("Target", 8);--Test what happens if not raid leader or assist
            end
        end
    end
end


function DrawTAMinimapIcon()
    LibStub("LibDBIcon-1.0"):Register("TargetAssist", LibStub("LibDataBroker-1.1"):NewDataObject("TargetAssist",
	{
		type = "data source",
		text = addonName,
		icon = "Interface\\Icons\\Ability_CheapShot",
        OnClick = function(self, button)
            if (button == "LeftButton") then
				OnMyTarget()
			elseif (button == "MiddleButton") then
                if(UnitName("target")) then
                    SetAssist()
                end
            elseif (button == "RightButton") then
                TAassistPlayer = nil
                TAAlertGroup = {}
            end
		end,
		OnTooltipShow = function(tooltip)
            tooltip:AddDoubleLine(format("%s", addonName), format("|cff7f7f7fv%s", GetAddOnMetadata(addonName, "Version")));
            tooltip:AddLine("|cff7f7f7fby Reziarfg|r");
            tooltip:AddLine("|cFFCFCFCFCurrent Assist: |cffD9534F"..TAassistPlayer.."|r");
            tooltip:AddLine("|cFFCFCFCFLeft Click: Attack my target!");
            tooltip:AddLine("|cFFCFCFCFMiddle Click: Set target assist player");
            tooltip:AddLine("|cFFCFCFCFRight Click: Clear Assist and Announce Group");--Change to options at future date
		end
    }),TargetAssist.db.profile.minimap);
end



local Assist = CreateFrame("Button", "AssistButton", UIParent, "SecureActionButtonTemplate")
Assist:SetAttribute("type", "macro")
Assist:Hide()
TargetAssist.Assist = Assist
Assist:SetPoint("BOTTOM", UIParent, 0, 135)
Assist:SetScale(1.75)
Assist:SetWidth(150)
--Assist:GetHotkey()
Assist:SetHeight(42)
Assist:SetMovable(true)
Assist:SetUserPlaced(true)
Assist:SetClampedToScreen(true)
Assist:SetFrameStrata"FULLSCREEN_DIALOG"
Assist:SetNormalTexture[[Interface\ACHIEVEMENTFRAME\UI-Achievement-Alert-Background-Mini]]

local SetAssistBtn = CreateFrame("Button", "SetAssistBtn",UIParent,"SecureActionButtonTemplate")--Keybind for switching to the focus target
SetAssistBtn:SetAttribute("type", "macro")
SetBindingClick("SHIFT-'", SetAssistBtn:GetName())
TargetAssist.SetAssistBtn = SetAssistBtn


function SetAssistBtn:AssistPlayer(TAassistTarget)
    self:SetAttribute("macrotext", "/cleartarget\n/targetexact " .. TAassistTarget)
end

function Assist:AssistPlayer(TAassistTarget)
    self:SetText(TAassistTarget)
    self:SetAttribute("macrotext", "/cleartarget\n/targetexact " .. TAassistTarget)
    self:Show()
    if not AudioDiff or GetTime() - AudioDiff > 8 then
        PlaySoundFile([[Interface\AddOns\Target Assist\hit-it-like-you-mean-it.ogg]],"Master")
        AudioDiff = GetTime()
    end
    TargetAssist.SetAssistBtn:AssistPlayer(TAassistTarget)
end

local closeAssist = CreateFrame("Button",nil,Assist,"UIPanelCloseButton")
closeAssist:SetPoint("TOPRIGHT",0,0)
closeAssist:SetWidth(32)
closeAssist:SetHeight(32)
closeAssist:SetScale(.8)
closeAssist:SetHitRectInsets(8, 8, 8, 8)


local TargetName = Assist:CreateFontString(nil,"OVERLAY","GameFontHighlightMedium")
TargetName:SetWordWrap(false)
Assist:SetFontString(TargetName)


local function table_contains(table, element)
    for _, value in pairs(table) do
      if value == element then
        return true
      end
    end
    return false
end

function TargetAssist:PLAYER_ENTERING_WORLD(self, arg1,arg2,arg3,arg4,...)--update args to sensible names
    if(TAAlertGroup == nil) then 
        TAAlertGroup = {}
        TAassistPlayer = nil
    end
end

function TargetAssist:CHAT_MSG_ADDON(self, prefix,text,channel,senderrealm,...)
        if(prefix == "TAssist") then
            local sender,realm = strsplit("-", senderrealm)
            local subject, action = strsplit("&", text, 3)
            if(action == "Register" and (not(table_contains(TAAlertGroup,subject)))) then--move to a separate function?
                table.insert(TAAlertGroup,subject)
            elseif(action == "LeadRegister") then
                LeadAssist(subject,sender)
            elseif(action == "Attack") then
                if(TAassistPlayer == sender) then--Verifies an agreement between the assist and player then targets their target
                    TargetAssist.Assist:AssistPlayer(subject)
                end
            end
    end
end

function TargetAssist:PLAYER_LOGIN(self, arg1,arg2,arg3,arg4,...)--update args to sensible names
    successfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("TAssist")
end

local AssistBtn = CreateFrame("BUTTON", "AssistBtn")--,UIParent,"SecureActionButtonTemplate")--Keybind for attack my target!
--AssistBtn:GetHotkey()
SetBindingClick("SHIFT-;", AssistBtn:GetName())--Keybind for clicking assist target button. Replace with something dynamic
AssistBtn:SetScript("OnClick", function(self, button, down)
    OnMyTarget()
end)
--[[
local f  = Test or CreateFrame("Frame", "Test", UIParent)
 
local function TestPrint(self, key)
   print(self:GetName(), key)
end
 
f:SetScript("OnKeyDown", TestPrint)
f:SetPropagateKeyboardInput(true)
--]]


--[[function Assist:OnEnter()
    print("entered")
    local button = this
    if (button.GetHotkey) then
        kb:Set(button)
    end
end--]]

SLASH_taa1 = "/taa"

SlashCmdList["taa"] = TAAssist
